# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Study_Python
# FileName:      test_case_004.py
# Author:       xxxxxxx
# Datetime:     2023/8/7 19:49
# Description:
# 
# ---------------------------------------------------------------------------
import logging
import re

import allure
import pytest

from Request_framework.study_004.common.readexcel_004 import Read_excel_004


class Test_bpm_004:

    @allure.epic('BPM系统')
    @pytest.mark.parametrize("module, interface, title, level, method, url, mime, data, expect, sql_type, sql_sentence,"
                             " update_key", Read_excel_004().into_list())
    def test_004(self, resp_fix, db4_fix, module, interface, title, level, method, url, mime, data, expect, sql_type,
                 sql_sentence, update_key):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)
        if sql_type == "delete":
            db4_fix.delete(sql_sentence)
        elif sql_type == "select":
            select_result = db4_fix.select(sql_sentence)
            data[update_key] = select_result
        elif sql_type == "delete|select" or sql_type == "select|delete":
            db4_fix.delete(sql_sentence["delete"])
            select_result = db4_fix.select(sql_sentence["select"])
            data[update_key] = select_result
        result = resp_fix.request_all(req_method=method, req_url=url, req_mime=mime, case_data=data)

        # 断言
        try:
            for key in expect:
                assert expect[key] == result.json().get(key)
        except:
            print("断言失败")
            logging.error(
                 "断言失败, 模块名称为：{}，接口名称为：{}，用例标题：{}，用例为：{}，期望结果为：{}，服务器返回数据为：{}".format(
                     module, interface, title, str(data), str(expect), result.text))
            raise AssertionError("断言失败")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()